/* Implementation of TLNil class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLNil.m,v 1.5 1996/01/23 12:18:35 tiggr Exp $  */

#import "tl/TLNil.h"
#import "tl/TLSymbol.h"
#import "tl/support.h"
#import <stdio.h>

#define VOID_METHOD(X)	-(void) X { }
#define NIL_METHOD(X)	-X { return (nil); }
#define T_METHOD(X)	-X { return (Qt); }

@implementation TLNil

-(retval_t) forward: (SEL) selector : (FORWARD_ARGUMENTS) arg_frame
{
  formac (V_stderr_, @"warning: NIL does not respond to `%s'\n",
	  sel_get_name (selector));
  return (nil);
} /* -forward:: */

-(int) compare: o
{
  return (o != self);
} /* -compare: */

-nconc: o
{
  return (o);
} /* -nconc: */

/* This is *nasty* and needed for garbage collection.  It protects the
   actual object acting as NIL object.  */
-(void) __protectAgainstGC
{
  [super gcMark];
} /* __protectAgainstGC */

NIL_METHOD (car)

NIL_METHOD (cdr)

NIL_METHOD (delq: o)

NIL_METHOD (eval)

VOID_METHOD (gcMark)

NIL_METHOD (gcPurge)

NIL_METHOD (memq: o)

@end
