/* Implementation of TLRegex class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLRegex.m,v 1.2 1996/01/23 12:18:37 tiggr Exp $  */

#define TLREGEX_DECLARE_PRIVATE_METHODS
#import "tl/support.h"
#import "tl/TLPatchedRoots.h"
#import "tl/TLRegex.h"

@implementation TLRegex

+(TLRegex *) regexWithString: (id <TLString>) s
{
  return [[self gcAlloc] initWithString: s options: 0];
} /* +regexWithString: */

+(TLRegex *) regexWithString: (id <TLString>) s options: (int) o
{
  return [[self gcAlloc] initWithString: s options: o];
} /* +regexWithString:option: */

-(void) dealloc
{
  regfree (&pat);
} /* -dealloc */

-initWithString: (id <TLString>) s options: (int) o
{
  int sl = [s length];
  const char *ss = [s cString];
  const char *err = re_compile_pattern (ss, sl, &pat);

  if (err)
    {
      [self warning: "regex %#: %s", s, err];
      INIT_RETURN_NIL ();
    }

  if (o & TLSEARCH_REGEX_FAST)
    pat.fastmap = xmalloc (256);

  return self;
} /* -initWithPattern:options: */

-(const struct re_pattern_buffer *) compiledPattern
{
  return &pat;
} /* -compiledPattern */

@end
