/* Interface to TLBase64Stream classes.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLBase64Stream.h,v 1.3 1996/01/23 12:19:13 tiggr Exp $  */

#import "TLStreamStream.h"

/* Separate classes are used for input and output streams, since the
   semantics on encoding streams with interspersed read and write operations
   are dodgy.   */
@class TLBase64InputStream, TLBase64OutputStream;

@interface TLBase64Stream: TLStreamStream
{
  /* For an input stream: the most significant bits of the next decoded
     character reside in the least significant bits of BUFFER.  */
  int buffer;

  /* For an input stream, the number of bits from the next decoded character
     present in BUFFER, values (0, 6, 4, 2, 0, ...)*/
  int bits;

  /* Whether we've hit EOF.  */
  unsigned int eof: 1;
}

@end

@interface TLBase64InputStream: TLBase64Stream <TLStream, TLInputStream>
{
  /* Whether we've warned about bad characters in the input stream.  */
  unsigned int warned: 1;
}

@end

@interface TLBase64OutputStream: TLBase64Stream <TLStream, TLOutputStream>
{
  /* The number of character written this line.  */
  int col;
}

@end
