/* Interface to TLInetAddress class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLInetAddress.h,v 1.5 1996/01/23 12:19:18 tiggr Exp $  */

#import "TLSocketStream.h"
#import "TLString.h"
#import <sys/types.h>
#import <netinet/in.h>

@protocol TLInetAddress <TLNetworkAddress>

-(id <TLString>) protocol;

-(id <TLString>) hostname;

/* The port is the name of the service, or a port number.  */
-(id) port;

@end

@class TLInetSocketStream;

@interface TLInetAddress: TLObject <TLInetAddress>
{
  id host, protocol;

  id port;

  struct sockaddr_in address;
}

/* Return the port number to contact for the named port with the indicated
   protocol (usually `tcp' or `udp').  */
+(id <TLNumber>) portFromService: (id <TLString>) name
			protocol: (id <TLString>) protocol;

/* Return an address.  The protocol is needed since each protocol has a
   separate port namespace.  */
+(TLInetAddress *) addressWithProtocol: (id <TLString>) protocol
				  port: (id) portname
				  host: (id <TLString>) hostname;

#ifdef TLINETADDRESS_DECLARE_PRIVATE_METHODS

-initWithProtocol: (id <TLString>) proto
	     host: (id <TLString>) hostname
	     port: (id) portname;

-initWithAddress: (void *) addr length: (int) len;

#endif

@end
