/* Interface to TLUnixAddress class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLUnixAddress.h,v 1.2 1996/01/23 12:19:26 tiggr Exp $  */

#import "TLSocketStream.h"
#import "TLString.h"
#import <sys/types.h>
#import <sys/un.h>

@protocol TLUnixAddress <TLNetworkAddress>

-(id <TLString>) pathname;

@end

@class TLUnixSocketStream;

@interface TLUnixAddress: TLObject <TLUnixAddress>
{
  id <TLString> pathname;

  struct sockaddr_un address;
}

/* Create an address.  The stream S is needed for the protocol being used,
   since each protocol has a separate port namespace.  */
+(TLUnixAddress *) addressWithPathname: (id <TLString>) pathname;

@end
