/* Interface to TLWrapStream class.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: TLWrapStream.h,v 1.3 1996/01/23 12:19:27 tiggr Exp $  */

#import "TLStreamStream.h"
#import "buffer.h"

@class TLString;

@interface TLWrapStream: TLStreamStream <TLOutputStream>
{
  /* The buffer used for building lines.  */
  tlbuffer buf;

  /* The maximum length of a line.  */
  int line;

  /* Iff !0, we're to obey new-lines.  Otherwise, we only obey double
     new-lines.*/
  unsigned int obey_nl: 1;

  /* Iff !0, we're strict and might just as well not have been here.  */
  unsigned int strict_nl: 1;

  /* Iff !0, the last character was a new-line.  */
  unsigned int seen_nl: 1;
}

-obeysNewlines;
-setObeysNewlines: nil_or_t;

-strictNewlines;
-setStrictNewlines: nil_or_t;

@end
