/* Header file to TLL subroutines.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: subr.h,v 1.9 1996/01/23 12:19:29 tiggr Exp $  */

#import "TLLSubroutine.h"
#import "TLFDStream.h"
#import "config.h"

/* Initialize subroutines.  */
void tll_subr_init (void);

@class TLSymbol;
/* Symbols of subroutines whose name is ever referenced within the Library
   in Objective-C code.  */
extern TLSymbol *Qquote;

id Fadd (id args, int num_args);
id Fand (id args);
id Fbind (id address);
id Fcar (id cons);
id Fcdr (id cons);
id Fcntl (id <TLStream> stream, id clear, id set);
id Fcond (id args);
id Fconnect (id address);
id Fcons (id car, id cdr);
id Fcrypt (id <TLString> p, id <TLString> s);
id Fdefun (id args);
id Fdiv (id args, int num_args);
id Feq (id arg1, id arg2);
id Feval_string (id string);
id Fexec (id <TLString> path, TLCons *arglist, TLCons *streams);
id Fexit (id <TLNumber> val);
TLFDStream *Ffd_stream (id <TLString> name, TLCons *mode,
			id <TLNumber> protection);
id Ffork (void);
id Fformac (id args);
id Fgarbage_collect (id <TLNumber> usec);
id Fge (id a1, id a2);
id Fgetenv (id <TLString> n);
id Fgetpgrp (id <TLNumber> pid);
id Fgt (id a1, id a2);
id Fhostname (void);
id Fif (id args);
TLSymbol *Fintern (id <TLString> name);
id Flambda (id args);
id Fle (id a1, id a2);
id Flet (id args);
id Flet_star (id args);
id Flt (id a1, id a2);
id Fmake_inet_address (id s, id p, id h);
id Fmake_unix_address (id path);
id Fmapcar (id sym, id seq);
id Fmatch_beginning (id <TLNumber> group);
id Fmatch_end (id <TLNumber> group);
id Fmatch_range (id <TLNumber> group);
id Fminusminus (id arg);
id Fmul (id args, int num_args);
id Fnconc (id argvec, int num_args);
id Fne (id a1, id a2);
id Fnot (id args);
id Fnumeric_eq (id a1, id a2);
id Foneminus (id arg);
id Foneplus (id arg);
id For (id args);
id Fperform (id args, int num_args);
id Fplusplus (id arg);
id Fprogn (id args);
id Fputenv (id <TLString> viv);
id Fquote (id args);
id Frandom (void);
id Frange (id start, id length, id end);
id Fread_with_timeout (id <TLBufferedInputStream, TLInputStream, TLStream>
		       stream, id timeout, id reply_ok, id reply_fail);
id Fselector_type (id <TLString> sel_name);
id Fsetq (id args);
id Fsetpgid (id <TLNumber> pid, id <TLNumber> pgid);
id Fsetsid (void);
id Fsleep (id <TLNumber> seconds);
id Fsub (id args, int num_args);
id Fstream_on_syslog (id <TLString> prog);
id Ftime (id args);
id Fvector (id args, int num_args);
id Fwait (id <TLNumber> pid);
id Fwhile (id args);
