/* Include-everything header for tl.
   This file is part of TL, Tiggr's Library.
   Written by Tiggr <tiggr@es.ele.tue.nl>
   Copyright (C) 1995, 1996 Pieter J. Schoenmakers
   TL is distributed WITHOUT ANY WARRANTY.
   See the file LICENSE in the TL distribution for details.

   $Id: tl.h,v 1.12 1996/01/23 12:19:31 tiggr Exp $  */

/* It seems vital (on hppa GCC 2.6.3, 2.7.1) to include stdarg before
   anything else from std.  Oh, if this include is changed into an import,
   it won't work either...  */
#include <stdarg.h>

#import "policy.h"
#import "config.h"

/* `Root' class.  */
#import "TLObject.h"

/* Reference counting glue (and other stuff).  */
#import "NSAutoreleasePool.h"
#import "TLPatchedRoots.h"

/* Predicates. */
#import "predicates.h"

/* Protocols and classes.  */
#import "TLBase64Stream.h"
#import "TLBufferedStream.h"
#import "TLBufferedMutableStream.h"
#import "TLCons.h"
#import "TLDate.h"
#import "TLDictionary.h"
#import "TLEnumerator.h"
#import "TLFDStream.h"
#import "TLFILEStream.h"
#import "TLFilename.h"
#import "TLHTTPStream.h"
#import "TLInetAddress.h"
#import "TLInetSocketStream.h"
#import "TLLDelegate.h"
#import "TLLInvocation.h"
#import "TLLLambda.h"
#import "TLLLex.h"
#import "TLLSubroutine.h"
#import "TLLTag.h"
#import "TLMimeItem.h"
#import "TLMutableString.h"
#import "TLNil.h"
#import "TLNumber.h"
#import "TLRange.h"
#import "TLRegex.h"
#import "TLRunLoop.h"
#import "TLSet.h"
#import "TLSneakStream.h"
#import "TLSocketStream.h"
#import "TLStack.h"
#import "TLStream.h"
#import "TLStreamStream.h"
#import "TLString.h"
#import "TLStringStream.h"
#import "TLSymbol.h"
#import "TLSyslogStream.h"
#import "TLTelnetStream.h"
#import "TLTrie.h"
#import "TLURL.h"
#import "TLUnixAddress.h"
#import "TLUnixSocketStream.h"
#import "TLVector.h"
#import "TLWrapStream.h"

/* Support.  */
#import "buffer.h"
#import "regex.h"
#import "subr.h"
#import "support.h"
#import "term.h"
#import "TLGC.h"

extern void tl_init (void);
